package com.sun.org.glassfish.gmbal;

import java.lang.annotation.Inherited;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Retention;
import java.lang.annotation.ElementType;
import java.lang.annotation.Target;
import java.lang.annotation.Documented;

@Documented
@Target({ ElementType.TYPE })
@Retention(RetentionPolicy.RUNTIME)
@Inherited
public @interface AMXMetadata {
    @DescriptorKey("amx.isSingleton")
    public abstract boolean isSingleton() default false;
    
    @DescriptorKey("amx.group")
    public abstract String group() default "other";
    
    @DescriptorKey("amx.subTypes")
    public abstract String[] subTypes() default {};
    
    @DescriptorKey("amx.genericInterfaceName")
    public abstract String genericInterfaceName() default "com.sun.org.glassfish.admin.amx.core.AMXProxy";
    
    @DescriptorKey("immutableInfo")
    public abstract boolean immutableInfo() default true;
    
    @DescriptorKey("interfaceName")
    public abstract String interfaceClassName() default "";
    
    @DescriptorKey("type")
    public abstract String type() default "";
}
